Project JEDI - Issue Tracker
Mantis Bugtracker

Viewing Issue Simple Details Jump to Notes ] View Advanced ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0005636 [JEDI VCL] 00 JVCL Components crash always 2011-08-10 11:44 2011-09-21 14:10
Reporter Mad Cat View Status public  
Assigned To outchy
Priority normal Resolution fixed  
Status resolved   Product Version 3.40
Summary 0005636: JvBandObject NX/DEP memory protection error
Description Using JvBandObject with turned-on hardware and software DEP/NX causes an exception.

According to this article http://blogs.msdn.com/b/ie/archive/2008/04/08/ie8-security-part-i_3a00_-dep-nx-memory-protection.aspx [^] problem is, of course, in DEP/NX.
Additional Information Using a dirty little hack I forced it work.
I've commented everything associated with hook (FHook, SetWindowsHookEx, UnhookWindowsHookEx) and it began to work.

I don't know how to fix it properly =(
Tags No tags attached.
Attached Files ? file icon JvBandObject.pas [^] (34,276 bytes) 2011-08-10 11:44
zip file icon BandTestProject.zip [^] (10,644 bytes) 2011-08-11 10:07

- Relationships

-  Notes
(0018856)
outchy (administrator)
2011-08-10 19:22

The faulty code is in the function MethodToProcedure, such code manipulation should be avoided in a DEP/NX enabled environment.
(0018858)
outchy (administrator)
2011-08-10 22:47

I don't know this part of the JVCL very well but I should be able to correctly fix the faulty stuff. Could you tell me how to rightly use a JvBandObject?
(0018859)
Mad Cat (reporter)
2011-08-10 23:57

Thanks for feedback.
Huh, I'll try to attach zip-file with sample project during next 12 hours.
(0018860)
Mad Cat (reporter)
2011-08-11 10:10

Project attached.
I've watched 'MethodToProcedure' function body. Wha'da dirty hack used O_O
(0018861)
outchy (administrator)
2011-08-11 10:53

I can't say more... being investigated...
(0018862)
outchy (administrator)
2011-08-11 11:54

Everything is messed up in IE6 as soon as I install either your toolbar or a new one created from the expert. Which version of IE are you using?
(0018863)
Mad Cat (reporter)
2011-08-11 12:38

As described in article above, this reproduced in IE8 and later.
(0018864)
Mad Cat (reporter)
2011-08-11 12:46

Simply, delphi compiler have no option similar to '/NXCompat' that in MSVC compiler. I haven't found such.
(0018865)
outchy (administrator)
2011-08-11 12:50

oups did not notice it, I've just installed IE8 and it looks a little bit better. Except that the bar is not "docked": the form is displayed at the top of the screen on top of IE8... Anyway that's an other issue and I'll fix the DEP/NX stuff first.
(0018866)
outchy (administrator)
2011-08-11 13:22

I committed a patch in revision 13094 that should fix DEP/NX issues and keep the hook enabled.

However, as I said before the toolbar is not docked in IE8, it is badly positioned at the top of the screen. But I do not know how to solve this issue yet, I could not find obvious errors while debugging the JvBand* units. Help is appreciated.
(0018867)
Mad Cat (reporter)
2011-08-11 14:02

Bug fixed successfully. Tested. It works fine. Thanks=)

About hard-fixed positioning. I think problem is in IE. Documentation in MSDN about creating tool-bars is poor and is already outdated.

Besides, Microsoft didn't provide native managed (.NET) component for creating tool-bars! All I found is 3rd party library, written by an enthusiast.

- Issue History
Date Modified Username Field Change
2011-08-10 11:44 Mad Cat New Issue
2011-08-10 11:44 Mad Cat File Added: JvBandObject.pas
2011-08-10 19:22 outchy Note Added: 0018856
2011-08-10 22:47 outchy Note Added: 0018858
2011-08-10 23:57 Mad Cat Note Added: 0018859
2011-08-11 10:07 Mad Cat File Added: BandTestProject.zip
2011-08-11 10:10 Mad Cat Note Added: 0018860
2011-08-11 10:53 outchy Note Added: 0018861
2011-08-11 11:54 outchy Note Added: 0018862
2011-08-11 12:38 Mad Cat Note Added: 0018863
2011-08-11 12:46 Mad Cat Note Added: 0018864
2011-08-11 12:50 outchy Note Added: 0018865
2011-08-11 13:22 outchy Note Added: 0018866
2011-08-11 14:02 Mad Cat Note Added: 0018867
2011-08-24 15:56 outchy Status new => resolved
2011-08-24 15:56 outchy Fixed in Version => Daily / SVN
2011-08-24 15:56 outchy Resolution open => fixed
2011-08-24 15:56 outchy Assigned To => outchy
2011-09-21 14:10 obones Fixed in Version Daily / SVN => 3.45


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker